## sagemath 9.4

=== debian/changelog ===
sagemath (9.4-2) unstable; urgency=medium

  [ Tobias Hansen ]
  * Remove (Build-)Depends:
    - libfplll-dev
  * Autopkgtests:
    - Do not run long tests to avoid timeouts.
    - Set restriction skip-not-installable since sagemath
      is not available on all architectures.

  [ Nilesh Patra ]
  * New patches:
    - u3-fix-i386-build.patch                   #33073

 -- Tobias Hansen <thansen@debian.org>  Wed, 29 Dec 2021 13:17:02 +0000

sagemath (9.4-1) unstable; urgency=medium

  * New upstream release. (Closes: #951592, #960925, #964848,
    #984326, #986527, #993149, #998190)
  * Doctests work out of the box now. (Closes: #931223)
  * Build standard python package python3-sage.
  * Install scripts to /usr/bin (Closes: #972346)
  * Activate autopkgtest.
  * Move package to Debian Math Team.
  * New (Build-)Depends:
    - Use dependencies as provided by upstream (drop many).
    - libec-dev (>= 20210503)
    - python3-memory-allocator
    - python3-sphinx (>= 4.3.1-2) (includes fix to dh_sphinxdoc)
    - singular (>= 1:4.2.1-p2)
  * Add dependency on libjs-mathjax to sagemath-doc.
    (Closes: #988681)
  * Run dh_sphinxdoc again.
  * New patches:
    - u0-trac32799-set-MPMATH_SAGE.patch         #32799
    - u0-version-arb-2.21.patch                  #32567
    - u0-version-matplotlib-3.5.patch            #32909
    - u0-version-singular-4.2.1.patch            #32001
    - u0-version-singular-4.2.1p2.patch          #32907
    - u0-version-lcalc-2.0.patch                 #32037
    - u0-version-linbox-1.7.patch                #32959
    - u0-version-gsl-2.7.patch                   #32607
    - u0-version-sphinx-4.3.patch                #32968
    - u1-close-the-internal-pipe-of-multiprocessing.Process.patch
    - dt-version-ipywidgets-6-revert-31517.patch
  * Remove patches (applied upstream):
    - u0-version-pari-2.13-spkg-configure.patch  #30906
    - u0-version-pari-2.13.patch                 #30801
    - u0-version-gap-4.11.patch                  #29314
    - u0-version-flint-2.6.3.patch               #29719
    - d1-no-spkg-builds.patch
    - d1-system-python-packages.patch
    - dt-avoid-pari-timeout.patch
  * Remove patches (no longer required):
    - u1-scripts-dir.patch                       #22731
    - d0-gsl-cblas.patch
    - d0-libgap-path.patch
    - d0-singular.patch
    - d0-docbuild-main.patch
    - d1-sage-env.patch
    - d1-sage.patch
    - dt-avoid-giac-segfault.patch
    - dt-avoid-ecl-timeout.patch
  * Use dephelper-compat level 13.

 -- Tobias Hansen <thansen@debian.org>  Sat, 18 Dec 2021 00:15:17 +0000

=== debian/control ===
## DO NOT EDIT debian/control directly, edit debian/control.in instead
Source: sagemath
Section: math
Priority: optional
Maintainer: Debian Math Team <team+math@tracker.debian.org>
Uploaders: Tobias Hansen <thansen@debian.org>,
           Julien Puydt <jpuydt@debian.org>,
           Jerome Benoit <calculus@rezozer.net>,
           Ximin Luo <infinity0@debian.org>
Standards-Version: 4.6.0
Homepage: http://www.sagemath.org/
Vcs-Git: https://salsa.debian.org/math-team/sagemath.git
Vcs-Browser: https://salsa.debian.org/math-team/sagemath
Rules-Requires-Root: no
Build-Depends:
 autoconf,
 debhelper (>= 13~),
 debhelper-compat (= 13),
 dh-python (>= 2.20170125),
 dpkg-dev (>= 1.17.14),
 pkg-config,
 python3-debian,
 python3-dev,
 python3-dbg,
 rdfind,
# Dependencies provided by upstream doc in sage/src/doc/en/installation/debian.txt:
 bc,
 binutils,
 bzip2,
 ca-certificates,
 cliquer,
 cmake,
 curl,
 ecl,
 eclib-tools,
 fflas-ffpack,
 flintqs,
 gfan,
 gfortran,
 glpk-utils,
 gmp-ecm,
 lcalc,
 libcdd-tools,
 m4,
 nauty,
 openssl,
 palp,
 pari-doc,
 pari-elldata,
 pari-galdata,
 pari-galpol,
 pari-gp2c,
 pari-seadata,
 patch,
 perl,
 pkg-config,
 planarity,
 python3,
 python3-distutils,
 r-base-dev,
 r-cran-lattice,
 sqlite3,
 sympow,
 tachyon,
 tox,
 xcas,
 xz-utils,
 yasm,
# Library dependencies provided by upstream doc in sage/src/doc/en/installation/debian.txt:
 libatomic-ops-dev,
 libboost-dev,
 libbraiding-dev,
 libbrial-dev,
 libbrial-groebner-dev,
 libbz2-dev,
 libcdd-dev,
 libcliquer-dev,
 libcurl4-openssl-dev,
 libec-dev,
 libecm-dev,
 libffi-dev,
 libflint-arb-dev,
 libflint-dev,
 libfreetype6-dev,
 libgc-dev,
 libgd-dev,
 libgf2x-dev,
 libgiac-dev,
 libgivaro-dev,
 libglpk-dev,
 libgmp-dev,
 libgsl-dev,
 libhomfly-dev,
 libiml-dev,
 liblfunction-dev,
 liblrcalc-dev,
 liblzma-dev,
 libm4rie-dev,
 libmpc-dev,
 libmpfi-dev,
 libmpfr-dev,
 libncurses5-dev,
 libntl-dev,
 libopenblas-dev,
 libpari-dev,
 libpcre3-dev,
 libplanarity-dev,
 libppl-dev,
 libpython3-dev,
 libreadline-dev,
 librw-dev,
 libsqlite3-dev,
 libssl-dev,
 libsuitesparse-dev,
 libsymmetrica2-dev,
 libz-dev,
 libzmq3-dev,
 libzn-poly-dev,
 ppl-dev,
# Additional dependencies not provided by upstream:
 python3-memory-allocator,
 python-ppl-doc,
 singular (>= 1:4.2.1-p2+ds-3),
 gap-dev (>= 4.11.0),
 gap-online-help,
 gap-atlasrep (>= 2.1.0-2),
 gap-primgrp,
 gap-smallgrp,
 gap-transgrp,
 gap-table-of-marks,
 jmol,
 libjs-mathjax,
 libjs-three (>= 111),
 liblinbox-dev (>= 1.7.0-2),
 libsingular4-dev (>= 1:4.2.1-p2+ds-3),
 maxima-sage (>= 5.44.0),
 maxima-sage-share (>= 5.44.0),
 sagemath-database-conway-polynomials (>= 0.5-7),
 sagemath-database-elliptic-curves,
 sagemath-database-graphs,
 sagemath-database-mutually-combinatorial-designs,
 sagemath-database-polytopes,
# Additional library dependencies not provided by upstream:
 libgap-dev,
 libpynac-dev (>= 0.7.29-2),
 libratpoints-dev,
 maxima-sage-doc (>= 5.42.2),
 pari-doc (>= 2.11.0),
 python3-sagenb-export (>= 3.2),
 singular-doc (>= 1:4.2.1-p2+ds-3),
# Python dependencies from sagelib's install_requires:
 python3-ipykernel,
 python3-ipython,
 python3-ipywidgets (>= 6.0.0),
 python3-jupyter-client,
 python3-jupyter-core,
# Additional dependencies not provided by upstream:
 jupyter-nbextension-jupyter-js-widgets,
 python3-nbconvert,
 python3-nbformat,
 python3-notebook (>= 4.2.3-3),
# Python dependencies from sagelib's install_requires:
 cython3 (>= 0.29.1),
 python3-cypari2 (>= 2.1),
 python3-fpylll (>= 0.4.1),
 python3-gmpy2,
 python3-jinja2,
 python3-matplotlib (>= 2.1),
 python3-mpmath,
 python3-networkx (>= 2.2),
 python3-numpy (>= 1:1.14),
 python3-pexpect (>= 4.1),
 python3-pil,
 python3-pkgconfig,
 python3-ppl,
 python3-psutil,
 python3-rpy2,
 python3-scipy (>= 1.2),
 python3-six (>= 1.15.0),
 python3-sphinx (>= 4.3.1-2),
 python3-sympy,

Package: sagemath
Architecture: all
Description: Open Source Mathematical Software
 SageMath is a free open-source mathematics software system licensed under the
 GPL. It builds on top of many existing open-source packages: NumPy, SciPy,
 matplotlib, Sympy, Maxima, GAP, FLINT, R and many more. Access their combined
 power through a common, Python-based language or directly via interfaces or
 wrappers.
 .
 Mission: Creating a viable free open source alternative to Magma, Maple,
 Mathematica and Matlab.
 .
 This package contains the main SageMath installation.
Depends: ${misc:Depends}, ${shlibs:Depends}, ${python3:Depends},
 python3-sage (>= ${source:Version}), python3-sage (<< ${source:Version}.1~)
Recommends:
 sagemath-doc (= ${source:Version}),
 sagemath-jupyter (= ${source:Version}),
 sagetex,
 texlive-latex-base
Suggests:
 dot2tex,
 gap-design,
 gap-factint,
 gap-grape,
 gap-guava,
 gap-laguna,
 gap-sonata,
 gap-toric
Breaks: sagemath-common (<< 9.4-1)
Replaces: sagemath-common (<< 9.4-1)

Package: python3-sage
Section: python
Architecture: any
Depends: ${python3:Depends}, ${misc:Depends}, ${shlibs:Depends},
# Dependencies provided by upstream doc in sage/src/doc/en/installation/debian.txt:
 bc,
 binutils,
 bzip2,
 ca-certificates,
 cliquer,
 cmake,
 curl,
 ecl,
 eclib-tools,
 fflas-ffpack,
 flintqs,
 gfan,
 gfortran,
 glpk-utils,
 gmp-ecm,
 lcalc,
 libcdd-tools,
 m4,
 nauty,
 openssl,
 palp,
 pari-doc,
 pari-elldata,
 pari-galdata,
 pari-galpol,
 pari-gp2c,
 pari-seadata,
 patch,
 perl,
 pkg-config,
 planarity,
 python3,
 python3-distutils,
 r-base-dev,
 r-cran-lattice,
 sqlite3,
 sympow,
 tachyon,
 tox,
 xcas,
 xz-utils,
 yasm,
# Library dependencies provided by upstream doc in sage/src/doc/en/installation/debian.txt:
 libatomic-ops-dev,
 libboost-dev,
 libbraiding-dev,
 libbrial-dev,
 libbrial-groebner-dev,
 libbz2-dev,
 libcdd-dev,
 libcliquer-dev,
 libcurl4-openssl-dev,
 libec-dev,
 libecm-dev,
 libffi-dev,
 libflint-arb-dev,
 libflint-dev,
 libfreetype6-dev,
 libgc-dev,
 libgd-dev,
 libgf2x-dev,
 libgiac-dev,
 libgivaro-dev,
 libglpk-dev,
 libgmp-dev,
 libgsl-dev,
 libhomfly-dev,
 libiml-dev,
 liblfunction-dev,
 liblrcalc-dev,
 liblzma-dev,
 libm4rie-dev,
 libmpc-dev,
 libmpfi-dev,
 libmpfr-dev,
 libncurses5-dev,
 libntl-dev,
 libopenblas-dev,
 libpari-dev,
 libpcre3-dev,
 libplanarity-dev,
 libppl-dev,
 libpython3-dev,
 libreadline-dev,
 librw-dev,
 libsqlite3-dev,
 libssl-dev,
 libsuitesparse-dev,
 libsymmetrica2-dev,
 libz-dev,
 libzmq3-dev,
 libzn-poly-dev,
 ppl-dev,
# Additional dependencies not provided by upstream:
 python3-memory-allocator,
 python-ppl-doc,
 singular (>= 1:4.2.1-p2+ds-3),
 gap-dev (>= 4.11.0),
 gap-online-help,
 gap-atlasrep (>= 2.1.0-2),
 gap-primgrp,
 gap-smallgrp,
 gap-transgrp,
 gap-table-of-marks,
 jmol,
 libjs-mathjax,
 libjs-three (>= 111),
 liblinbox-dev (>= 1.7.0-2),
 libsingular4-dev (>= 1:4.2.1-p2+ds-3),
 maxima-sage (>= 5.44.0),
 maxima-sage-share (>= 5.44.0),
 sagemath-database-conway-polynomials (>= 0.5-7),
 sagemath-database-elliptic-curves,
 sagemath-database-graphs,
 sagemath-database-mutually-combinatorial-designs,
 sagemath-database-polytopes,
# Additional library dependencies not provided by upstream:
 libgap-dev,
 libpynac-dev (>= 0.7.29-2),
 libratpoints-dev,
Recommends:
 maxima-sage-doc (>= 5.42.2),
 pari-doc (>= 2.11.0),
 python3-sagenb-export (>= 3.2),
 singular-doc (>= 1:4.2.1-p2+ds-3),
Description: Open Source Mathematical Software - Python 3 library
 SageMath is a free open-source mathematics software system licensed under the
 GPL. It builds on top of many existing open-source packages: NumPy, SciPy,
 matplotlib, Sympy, Maxima, GAP, FLINT, R and many more. Access their combined
 power through a common, Python-based language or directly via interfaces or
 wrappers.
 .
 Mission: Creating a viable free open source alternative to Magma, Maple,
 Mathematica and Matlab.
 .
 This package installs the library for Python 3.
Breaks: sagemath (<< 9.4-1)
Replaces: sagemath (<< 9.4-1)

Package: sagemath-jupyter
Architecture: all
Description: Open Source Mathematical Software - Jupyter kernel
 SageMath is a free open-source mathematics software system licensed under the
 GPL. It builds on top of many existing open-source packages: NumPy, SciPy,
 matplotlib, Sympy, Maxima, GAP, FLINT, R and many more. Access their combined
 power through a common, Python-based language or directly via interfaces or
 wrappers.
 .
 Mission: Creating a viable free open source alternative to Magma, Maple,
 Mathematica and Matlab.
 .
 This package contains the Jupyter kernel of SageMath.
Depends: ${misc:Depends},
# Python dependencies from sagelib's install_requires:
 python3-ipykernel,
 python3-ipython,
 python3-ipywidgets (>= 6.0.0),
 python3-jupyter-client,
 python3-jupyter-core,
# Additional dependencies not provided by upstream:
 jupyter-nbextension-jupyter-js-widgets,
 python3-nbconvert,
 python3-nbformat,
 python3-notebook (>= 4.2.3-3),
 sagemath (= ${source:Version})

Package: sagemath-doc
Section: doc
Architecture: all
Multi-Arch: foreign
Build-Profiles: <!nodoc>
Description: Open Source Mathematical Software - documentation
 SageMath is a free open-source mathematics software system licensed under the
 GPL. It builds on top of many existing open-source packages: NumPy, SciPy,
 matplotlib, Sympy, Maxima, GAP, FLINT, R and many more. Access their combined
 power through a common, Python-based language or directly via interfaces or
 wrappers.
 .
 Mission: Creating a viable free open source alternative to Magma, Maple,
 Mathematica and Matlab.
 .
 This package contains the documentation.
Depends: ${misc:Depends}, ${sphinxdoc:Depends}, libjs-mathjax
Built-Using: ${sphinxdoc:Built-Using}
Breaks: sagemath-doc-ca (<< 8.9~beta9-1~), sagemath-doc-de (<< 8.9~beta9-1~),
 sagemath-doc-en (<< 8.9~beta9-1~), sagemath-doc-es (<< 8.9~beta9-1~),
 sagemath-doc-fr (<< 8.9~beta9-1~), sagemath-doc-hu (<< 8.9~beta9-1~),
 sagemath-doc-it (<< 8.9~beta9-1~), sagemath-doc-ja (<< 8.9~beta9-1~),
 sagemath-doc-pt (<< 8.9~beta9-1~), sagemath-doc-ru (<< 8.9~beta9-1~),
 sagemath-doc-tr (<< 8.9~beta9-1~)
Replaces: sagemath-doc-ca (<< 8.9~beta9-1~), sagemath-doc-de (<< 8.9~beta9-1~),
 sagemath-doc-en (<< 8.9~beta9-1~), sagemath-doc-es (<< 8.9~beta9-1~),
 sagemath-doc-fr (<< 8.9~beta9-1~), sagemath-doc-hu (<< 8.9~beta9-1~),
 sagemath-doc-it (<< 8.9~beta9-1~), sagemath-doc-ja (<< 8.9~beta9-1~),
 sagemath-doc-pt (<< 8.9~beta9-1~), sagemath-doc-ru (<< 8.9~beta9-1~),
 sagemath-doc-tr (<< 8.9~beta9-1~)

=== debian/rules ===
#!/usr/bin/make -f

#
# CONTENTS:
#
# 1. DEFINITIONS
# 2. GENERATE FILES
#    Targets to auto-generate files
# 3. PACKAGE BUILD
#    Mostly standard targets that are used during package build
# 4. TEST SUITE
# 5. MAINTAINER TARGETS
#    Convenience targets to be used by maintainers
#    Some are explained at https://wiki.debian.org/DebianScience/Sage
#

###############################################################################
# 1. DEFINITIONS
###############################################################################

include /usr/share/dpkg/pkg-info.mk
include /usr/share/dpkg/architecture.mk

ifneq (,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
export SAGE_NUM_THREADS = $(patsubst parallel=%,%,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
endif

# Some buildds are a bit slow, see https://buildd.debian.org/status/logs.php?pkg=gcc-7 for a fuller list
ifneq (,$(filter $(DEB_BUILD_ARCH),armel armhf mips mipsel mips64el))
export SAGE_TIMEOUT_LONG = 7200
else
export SAGE_TIMEOUT_LONG = 3600
endif

export HOME = $(CURDIR)
export PYBUILD_NAME = sage

%:
	dh $@ --with=python3,sphinxdoc --buildsystem=pybuild --sourcedir=sage/pkgs/sagemath-standard

###############################################################################
# 2. GENERATE FILES
###############################################################################

binary build clean install: debian/control

debian/control: debian/control.in
	cat $^ > "$@"
	sed -i -e '/RUNTIME_DEPENDS/ {' -e 'r debian/control.runtime-depends' -e 'd' -e '}' "$@"
	sed -i -e '/RUNTIME_RECOMMENDS/ {' -e 'r debian/control.runtime-recommends' -e 'd' -e '}' "$@"
	sed -i -e '/JUPYTER_DEPENDS/ {' -e 'r debian/control.jupyter-depends' -e 'd' -e '}' "$@"

###############################################################################
# 3. PACKAGE BUILD
###############################################################################

# We install directly after building in order to use the python package for
# docbuild and testing. This is required both for arch and indep builds.
debian/tmp/usr/bin/sage:
	cp -f debian/sage_conf.py sage/pkgs/sagemath-standard/
# Generate setup.cfg etc in sage/src from .m4 files:
	cd sage/build/pkgs/sagelib && SAGE_ROOT=$(CURDIR)/sage PATH=$(PATH):$(CURDIR)/sage/build/bin ./bootstrap
# Remove sage-conf from setup.cfg, it can lead to a dependency on sagemath-common
	sed -i '/sage_conf/d' sage/src/setup.cfg
	dh_auto_build
	dh_auto_install
	mkdir -p debian/tmp
	mv debian/python3-sage/usr debian/tmp/
	rm -rf debian/python3-sage
	mkdir -p debian/tmp/usr/lib/python3.9/dist-packages/
	cp -f debian/sage_conf.py debian/tmp/usr/lib/python3.9/dist-packages/

override_dh_auto_build-arch: debian/tmp/usr/bin/sage

override_dh_auto_build-indep: debian/tmp/usr/bin/sage
ifeq (,$(filter nodoc,$(DEB_BUILD_PROFILES)))
	cd sage && SAGE_ROOT=$(CURDIR)/sage PATH=$(PATH):$(CURDIR)/sage/build/bin src/doc/bootstrap
	mv sage/src/sage sage/src/sage.bak # Use the installed sage, not the one from the source tree
	cd sage/src && \
	export PYTHONPATH=$(CURDIR)/debian/tmp/usr/lib/python3.9/dist-packages \
	       SAGE_SRC=$(CURDIR)/sage/src \
	       SAGE_DOC_SRC=$(CURDIR)/sage/src/doc \
	       SAGE_DOC=$(CURDIR)/sage/src/doc \
	       MATHJAX_DIR=/usr/share/javascript/mathjax \
	       LANG=C && \
	python3 -m sage_docbuild --no-pdf-links --mathjax all html
	mv sage/src/sage.bak sage/src/sage
	mkdir -p debian/tmp/usr/share/doc/sagemath
	mv sage/src/doc/html debian/tmp/usr/share/doc/sagemath/
	cd debian/tmp/usr/share/doc/sagemath/html && \
	for statdir in */*/_static; do ln -s /usr/share/javascript/mathjax "$$statdir"; done && \
	for statdir in */_static; do ln -s /usr/share/javascript/mathjax "$$statdir"; done
endif

override_dh_auto_install:
# Delete .bat files
	rm -f debian/tmp/usr/bin/*.bat
# Install desktop file
	mkdir -p debian/tmp/usr/share/applications
	cp -f debian/sagemath.desktop debian/tmp/usr/share/applications/sagemath.desktop
# Install (renamed) icons.
	mkdir -p debian/tmp/usr/share/icons/hicolor/64x64/apps
	mkdir -p debian/tmp/usr/share/icons/hicolor/scalable/apps
	cp -f sage/src/sage/ext_data/notebook-ipython/logo-64x64.png debian/tmp/usr/share/icons/hicolor/64x64/apps/sagemath.png
	cp -f sage/src/sage/ext_data/notebook-ipython/logo.svg debian/tmp/usr/share/icons/hicolor/scalable/apps/sagemath.svg
# Fix links to icons.
	cd debian/tmp/usr/share/jupyter/kernels/sagemath && rm -f logo-64x64.png && \
	   ln -s ../../../icons/hicolor/64x64/apps/sagemath.png logo-64x64.png
	cd debian/tmp/usr/share/jupyter/kernels/sagemath && rm -f logo.svg && \
	   ln -s ../../../icons/hicolor/scalable/apps/sagemath.svg logo.svg

override_dh_prep:
# Prevent dh_prep from deleting debian/tmp.
	dh_prep -Xdebian/tmp

override_dh_install-indep:
	dh_install
ifeq (,$(filter nodoc,$(DEB_BUILD_PROFILES)))
# Basic version of deduplicating the docs, for a much smaller install size.
# Upstream bug report is at https://trac.sagemath.org/ticket/22088
# Hard links do work in Debian packages, but only within packages.
	rdfind -outputname /dev/null -makehardlinks true debian/sagemath-doc;
endif

override_dh_installman-indep:
	dh_installman -psagemath debian/sage.1

override_dh_missing:
	dh_missing --list-missing

override_dh_python3-arch:
	dh_python3
	dh_numpy3 --package python3-sage # stop lintian complaining at us

override_dh_compress:
# We probably don't need to install the pickle/doctree files but let's exempt
# them from compression anyway for now, so the build goes quicker.
	dh_compress -X.pdf -X.pickle -X.doctree

override_dh_sphinxdoc:
ifeq (,$(filter nodoc,$(DEB_BUILD_PROFILES)))
# TODO: fix MathJax.js, Sage needs special treatment
# `man dh_sphinxdoc` says symlinking translations.js is not yet supported
# likewise, it seems not to recognise searchtools.js yet
	dh_sphinxdoc -XMathJax.js -Xtranslations.js -Xsearchtools.js
endif

override_dh_clean:
	rm -rf .sage .texlive2021 debian/python3-sage-dbg
	rm -f sage/pkgs/sagemath-standard/sage_conf.py
	dh_clean

#override_dh_strip:
#	dh_strip -ppython3-sage --dbg-package=python3-sage-dbg

override_dh_strip_nondeterminism:
	dh_strip_nondeterminism -X.png # On png files it sometimes fails claiming it's not a png file.

###############################################################################
# 4. TEST SUITE
###############################################################################

ifeq (,$(filter pkg.sagemath.nolongcheck,$(DEB_BUILD_PROFILES)))
SAGE_TEST_FLAGS_ARCH = --optional=sage,python3,memlimit --long
SAGE_TEST_FLAGS_INDEP = --optional=sage,python3,memlimit,dochtml --long
else
SAGE_TEST_FLAGS_ARCH = --optional=sage,python3,memlimit
SAGE_TEST_FLAGS_INDEP = --optional=sage,python3,memlimit,dochtml
endif

TESTS_MK = $(MAKE) -s --no-print-directory -f debian/tests.mk LOGFILE=$(LOGFILE)

run_tests = \
	export PATH=$(PATH):$(CURDIR)/debian/tmp/usr/bin \
	       PYTHONPATH=$(CURDIR)/debian/tmp/usr/lib/python3.9/dist-packages \
	       SAGE_DOC=$(CURDIR)/sage/src/doc \
	       SAGE_LOCAL=/usr && cd sage && \
	sage -t -p $(SAGE_NUM_THREADS) --logfile=$(CURDIR)/sage/logs/ptestlong-$(1).log $(2)

run_tests_with_retry = \
	$(run_tests); cd "$(CURDIR)" && \
	if $(TESTS_MK) LOGFILE=sage/logs/ptestlong-$(1).log MAX_TEST_FAILURES=$(3) had-few-failures; then :; else \
	  $(TESTS_MK) LOGFILE=sage/logs/ptestlong-$(1).log MAX_TEST_FAILURES=$(3) had-not-too-many-failures && \
	  mv sage/logs/ptestlong-$(1).log sage/logs/ptestlong-$(1).log.1 && \
	  { $(run_tests) -p 1 -f; cd "$(CURDIR)" && \
	  $(TESTS_MK) LOGFILE=sage/logs/ptestlong-$(1).log MAX_TEST_FAILURES=$(3) had-few-failures; }; \
	fi

override_dh_auto_test-arch:
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
	mkdir -p sage/logs
	$(call run_tests_with_retry,arch,$(SAGE_TEST_FLAGS_ARCH) src/sage,150)
endif

override_dh_auto_test-indep:
ifeq (,$(filter nodoc,$(DEB_BUILD_PROFILES)))
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
	mkdir -p sage/logs
	$(call run_tests_with_retry,indep,$(SAGE_TEST_FLAGS_INDEP) src/doc src/sage/misc/sagedoc.py,25)

=== debian/tests/control ===
Test-Command: HOME=$(pwd) SAGE_SRC=$(pwd)/sage/src sage -t -p --logfile=ptestlong.log sage/src/sage || make -s --no-print-directory -f debian/tests.mk had-few-failures
Depends: sagemath-jupyter, sagemath-doc
Restrictions: rw-build-tree, skip-not-installable

## sagemath 9.5

=== sage/Makefile ===
# Main Makefile for Sage.

# The default target ("all") builds Sage and the whole (HTML) documentation.
#
# Target "build" just builds Sage.
#
# See below for targets to build the documentation in other formats,
# to run various types of test suites, and to remove parts of the build etc.

default: all

all: base-toolchain
	$(MAKE) all-start

build: base-toolchain
	$(MAKE) all-build

build-local: base-toolchain
	$(MAKE) all-build-local

build-venv: base-toolchain
	$(MAKE) all-build-venv

start: base-toolchain
	$(MAKE) build-start

sageruntime: base-toolchain
	$(MAKE) all-sageruntime


# The --stop flag below is just a random flag to induce graceful
# breakage with non-GNU versions of make.
# See https://trac.sagemath.org/ticket/24617

# Defer unknown targets to build/make/Makefile
%::
	@if [ -x relocate-once.py ]; then ./relocate-once.py; fi
	$(MAKE) build/make/Makefile --stop
	+build/bin/sage-logger \
		"cd build/make && ./install '$@'" logs/install.log

# CONFIG_FILES lists all files that appear in AC_CONFIG_FILES in configure.ac;
# except for build/make/Makefile-auto, which is unused by the build system
CONFIG_FILES = build/make/Makefile src/bin/sage-env-config build/bin/sage-build-env-config pkgs/sage-conf/sage_conf.py pkgs/sage-conf/setup.cfg

# SPKG_COLLECT_FILES contains all files that influence the SAGE_SPKG_COLLECT macro
SPKG_COLLECT_FILES = build/pkgs/*/type build/pkgs/*/package-version.txt build/pkgs/*/dependencies build/pkgs/*/requirements.txt build/pkgs/*/checksums.ini build/pkgs/*/spkg-install

# If configure was run before, rerun it with the old arguments.
# Otherwise, run configure with argument $PREREQ_OPTIONS.
build/make/Makefile: configure $(SPKG_COLLECT_FILES) $(CONFIG_FILES:%=%.in)
	rm -f config.log
	mkdir -p logs/pkgs
	ln -s logs/pkgs/config.log config.log
	@if [ -x config.status ]; then \
		./config.status --recheck && ./config.status; \
	else \
		echo >&2 '****************************************************************************'; \
		echo >&2 'error: Sage source tree is unconfigured. Please run "./configure" first.'; \
		echo >&2 'note:  Type "./configure --help" to see the available configuration options.'; \
		echo >&2 '****************************************************************************'; \
	        exit 1; \
	fi

# This is used to monitor progress towards Python 3 and prevent
# regressions. Should be removed after the full switch to python3.
#
# As of Sage 9.0: keep the build target for backward compatibility,
# but it just runs "make".
buildbot-python3:
	$(MAKE)

# Preemptively download all source tarballs of normal packages.
download:
	export SAGE_ROOT=$$(pwd) && \
	export PATH=$$SAGE_ROOT/build/bin:$$PATH && \
	sage-package download :all:

dist: build/make/Makefile
	./sage --sdist

pypi-sdists: sage_setup
	./sage --sh build/pkgs/sage_conf/spkg-src
	./sage --sh build/pkgs/sage_sws2rst/spkg-src
	./sage --sh build/pkgs/sage_docbuild/spkg-src
	./sage --sh build/pkgs/sage_setup/spkg-src
	./sage --sh build/pkgs/sagelib/spkg-src
	@echo "Built sdists are in upstream/"

# ssl: build Sage, and also install pyOpenSSL. This is necessary for
# running the secure notebook. This make target requires internet
# access. Note that this requires that your system have OpenSSL
# libraries and headers installed. See README.txt for more
# information.
ssl: all
	./sage -i pyopenssl

###############################################################################
# Cleaning up
###############################################################################

SAGE_ROOT = $(CURDIR)
SAGE_SRC = $(SAGE_ROOT)/src

clean:
	@echo "Deleting package build directories..."
	if [ -f "$(SAGE_SRC)"/bin/sage-env-config ]; then \
	    . "$(SAGE_SRC)"/bin/sage-env-config; \
	    if [ -n "$$SAGE_LOCAL" ]; then \
	        rm -rf "$$SAGE_LOCAL/var/tmp/sage/build"; \
	    fi; \
	fi

# "c_lib", ".cython_version", "build" in $(SAGE_SRC) are from old sage versions
# Cleaning .so files (and .c and .cpp files associated with .pyx files) is for editable installs.
# Also cython_debug is for editable installs.
sagelib-clean:
	@echo "Deleting Sage library build artifacts..."
	if [ -d "$(SAGE_SRC)" ]; then \
	    (cd "$(SAGE_SRC)" && \
	     rm -rf c_lib .cython_version cython_debug; \
	     rm -rf build; find . -name '*.pyc' -o -name "*.so" | xargs rm -f; \
	     rm -f $$(find . -name "*.pyx" | sed 's/\(.*\)[.]pyx$$/\1.c \1.cpp/'); \
	     rm -rf sage/ext/interpreters) \
	    && (cd "$(SAGE_ROOT)/build/pkgs/sagelib/src/" && rm -rf build); \
	fi

sage_docbuild-clean:
	(cd "$(SAGE_ROOT)/build/pkgs/sage_docbuild/src" && rm -rf build)

sage_setup-clean:
	(cd "$(SAGE_ROOT)/build/pkgs/sage_setup/src" && rm -rf build)

build-clean: clean doc-clean sagelib-clean sage_docbuild-clean

doc-clean:
	cd "$(SAGE_SRC)/doc" && $(MAKE) clean

# Deleting src/lib is to get rid of src/lib/pkgconfig
# that was forgotten to clean in #29082.
misc-clean:
	@echo "Deleting build artifacts generated by autoconf, automake, make ..."
	rm -rf logs
	rm -rf dist
	rm -rf tmp
	rm -f aclocal.m4 config.log confcache
	rm -rf autom4te.cache
	rm -f build/make/Makefile build/make/Makefile-auto
	rm -rf src/lib

bdist-clean: clean
	$(MAKE) misc-clean
	@echo "Deleting build artifacts generated by configure ..."
	rm -f config.status

distclean: build-clean
	$(MAKE) misc-clean
	@echo "Deleting all remaining output from build system ..."
	rm -rf local
	rm -f src/bin/sage-env-config
	rm -f prefix venv

# Delete all auto-generated files which are distributed as part of the
# source tarball
bootstrap-clean:
	rm -rf config configure build/make/Makefile-auto.in
	rm -f src/doc/en/installation/*.txt
	rm -rf src/doc/en/reference/spkg/*.rst
	rm -f src/doc/en/reference/repl/*.txt
	rm -f environment.yml
	rm -f src/environment.yml
	rm -f environment-optional.yml
	rm -f src/environment-optional.yml
	rm -f src/Pipfile
	rm -f src/pyproject.toml
	rm -f src/requirements.txt
	rm -f src/setup.cfg

# Remove absolutely everything which isn't part of the git repo
maintainer-clean: distclean bootstrap-clean
	rm -rf upstream

# Remove everything that is not necessary to run Sage and pass all its
# doctests.
micro_release:
	$(MAKE) sagelib-clean
	$(MAKE) misc-clean
	@echo "Stripping binaries ..."
	LC_ALL=C find local/lib local/bin -type f -exec strip '{}' ';' 2>&1 | grep -v "File format not recognized" |  grep -v "File truncated" || true
	@echo "Removing sphinx artifacts..."
	rm -rf local/share/doc/sage/doctrees local/share/doc/sage/inventory
	@echo "Removing documentation. Inspection in IPython still works."
	rm -rf local/share/doc local/share/*/doc local/share/*/examples local/share/singular/html
	@echo "Removing unnecessary files & directories - make will not be functional afterwards anymore"
	@# We need src/doc/common, src/doc/en/introspect for introspection with "??"
	@# We keep src/sage for some doctests that it expect it to be there and
	@# also because it does not add any weight with rdfind below.
	@# We need src/sage/bin/ for the scripts that invoke Sage
	@# We need sage, the script to start Sage
	@# We need local/, the dependencies and the built Sage library itself.
	@# We keep VERSION.txt.
	@# We keep COPYING.txt so we ship a license with this distribution.
	find . -name . -o -prune ! -name config.status ! -name src ! -name sage ! -name local ! -name VERSION.txt ! -name COPYING.txt ! -name build -exec rm -rf \{\} \;
	cd src && find . -name . -o -prune ! -name sage ! -name bin ! -name doc -exec rm -rf \{\} \;
	if command -v rdfind > /dev/null; then \
		echo "Hardlinking identical files."; \
		rdfind -makeresultsfile false -makehardlinks true .; \
	else \
		echo "rdfind not installed. Not hardlinking identical files."; \
	fi

# Leaves everything that is needed to make the next "make" fast but removes
# all the cheap build artifacts that can be quickly regenerated.
# Trac #30960: We no longer uninstall sagelib.
fast-rebuild-clean: misc-clean
	rm -rf upstream/
	rm -rf build/pkgs/sagelib/src/build/temp.*
	# The .py files in src/build are restored from src/sage without their
	# mtimes changed.
	-find build/pkgs/sagelib/src/build -name '*.py' -exec rm \{\} \;
	# Remove leftovers from ancient branches
	rm -rf src/build

TESTALL = ./sage -t --all
PTESTALL = ./sage -t -p --all

# Flags for ./sage -t --all.
# When the documentation is installed, "optional" also includes all tests marked 'sagemath_doc_html',
# see https://trac.sagemath.org/ticket/25345, https://trac.sagemath.org/ticket/26110, and
# https://trac.sagemath.org/ticket/32759
TESTALL_FLAGS = --optional=sage,optional,external,build

test: all
	$(TESTALL) --logfile=logs/test.log

check: test

testall: all
	$(TESTALL) $(TESTALL_FLAGS) --logfile=logs/testall.log

testlong: all
	$(TESTALL) --long --logfile=logs/testlong.log

testalllong: all
	$(TESTALL) --long $(TESTALL_FLAGS) --logfile=logs/testalllong.log

ptest: all
	$(PTESTALL) --logfile=logs/ptest.log

ptestall: all
	$(PTESTALL) $(TESTALL_FLAGS) --logfile=logs/ptestall.log

ptestlong: all
	$(PTESTALL) --long --logfile=logs/ptestlong.log

ptestalllong: all
	$(PTESTALL) --long $(TESTALL_FLAGS) --logfile=logs/ptestalllong.log

testoptional: all
	$(TESTALL) --logfile=logs/testoptional.log

testoptionallong: all
	$(TESTALL) --long --logfile=logs/testoptionallong.log

ptestoptional: all
	$(PTESTALL) --logfile=logs/ptestoptional.log

ptestoptionallong: all
	$(PTESTALL) --long --logfile=logs/ptestoptionallong.log

test-nodoc: build
	$(TESTALL) --logfile=logs/test.log

check-nodoc: test-nodoc

testall-nodoc: build
	$(TESTALL) $(TESTALL_FLAGS) --logfile=logs/testall.log

testlong-nodoc: build
	$(TESTALL) --long --logfile=logs/testlong.log

testalllong-nodoc: build
	$(TESTALL) --long $(TESTALL_FLAGS) --logfile=logs/testalllong.log

ptest-nodoc: build
	$(PTESTALL) --logfile=logs/ptest.log

ptestall-nodoc: build
	$(PTESTALL) $(TESTALL_FLAGS) --logfile=logs/ptestall.log

ptestlong-nodoc: build
	$(PTESTALL) --long --logfile=logs/ptestlong.log

ptestalllong-nodoc: build
	$(PTESTALL) --long $(TESTALL_FLAGS) --logfile=logs/ptestalllong.log

testoptional-nodoc: build
	$(TESTALL) --logfile=logs/testoptional.log

testoptionallong-nodoc: build
	$(TESTALL) --long --logfile=logs/testoptionallong.log

ptestoptional-nodoc: build
	$(PTESTALL) --logfile=logs/ptestoptional.log

ptestoptionallong-nodoc: build
	$(PTESTALL) --long --logfile=logs/ptestoptionallong.log

configure: bootstrap src/doc/bootstrap configure.ac src/bin/sage-version.sh m4/*.m4 build/pkgs/*/spkg-configure.m4 build/pkgs/*/type build/pkgs/*/distros/*.txt
	./bootstrap -d

install: all
	@echo "******************************************************************"
	@echo "The '$@' target is a no-op; 'make' already does 'make install'"
	@echo "You can change the install prefix from its default"
	@echo "(the subdirectory 'local') by using ./configure --prefix=PREFIX"
	@echo "You can also consider using the binary packaging scripts"
	@echo "from https://github.com/sagemath/binary-pkg"
	@echo "******************************************************************"

# Setting SAGE_PKGCONFIG is only so that make does not exit with
# "This Makefile needs to be invoked by build/make/install".
list:
	@$(MAKE) --silent build/make/Makefile >&2
	@$(MAKE) --silent -f build/make/Makefile SAGE_PKGCONFIG=dummy $@

.PHONY: default build dist install micro_release \
	misc-clean bdist-clean distclean bootstrap-clean maintainer-clean \
	test check testoptional testall testlong testoptionallong testallong \
	ptest ptestoptional ptestall ptestlong ptestoptionallong ptestallong \
	buildbot-python3 list \
	doc-clean clean sagelib-clean build-clean

=== sage/pkgs/sage-docbuild/requirements.txt ===
#sage
sphinx

=== sage/pkgs/sage-setup/requirements.txt ===
Cython
pkgconfig

=== sage/src/doc/Makefile ===
########################################################
#
# 'make doc-html' (synonym for 'make' and 'make all') builds the html documentation.
# 'make doc-pdf' builds the PDF documentation.
#
# SAGE_ROOT must be defined for these to work, so these commands
# should be called by build/make/Makefile.
#
# 'make clean' removes build artifacts; SAGE_ROOT need not be defined for this to work.

all: doc-html

clean:
	rm -rf en/reference/*/sage
	rm -rf en/reference/sage
	rm -f common/*.pyc

# Matches doc-inventory--reference-manifolds etc.
doc-inventory--%:
	cd $(SAGE_ROOT) && ./sage --docbuild --no-pdf-links $(subst -,/,$(subst doc-inventory--,,$@)) inventory $(SAGE_DOCBUILD_OPTS)

# Matches doc-html--developer, doc-html--reference-manifolds etc.
doc-html--%:
	cd $(SAGE_ROOT) && ./sage --docbuild --no-pdf-links $(subst -,/,$(subst doc-html--,,$@)) html $(SAGE_DOCBUILD_OPTS)

# reference manual, inventory
ifndef SAGE_ROOT
doc-inventory-reference:
	$(error SAGE_ROOT undefined. This Makefile needs to be invoked by build/make/install)
else
doc-inventory-reference:
	$(eval DOCS = $(shell cd $(SAGE_ROOT) && ./sage --docbuild --all-documents reference))
	@if [ -z "$(DOCS)" ]; then echo "Error: './sage --docbuild --all-documents' failed"; exit 1; fi
	$(eval BIBLIO = $(firstword $(DOCS)))
	$(eval OTHER_DOCS = $(wordlist 2, 100, $(DOCS)))
	$(MAKE) doc-inventory--$(subst /,-,$(BIBLIO))
	$(MAKE) SAGE_DOCBUILD_OPTS="$(SAGE_DOCBUILD_OPTS) --no-prune-empty-dirs" $(foreach doc, $(OTHER_DOCS), doc-inventory--$(subst /,-,$(doc)))
	$(MAKE) SAGE_DOCBUILD_OPTS="$(SAGE_DOCBUILD_OPTS) --no-prune-empty-dirs" doc-inventory--reference_top
endif

# reference manual, html
doc-html-reference: doc-inventory-reference
	$(eval DOCS = $(shell cd $(SAGE_ROOT) && ./sage --docbuild --all-documents reference))
	@if [ -z "$(DOCS)" ]; then echo "Error: './sage --docbuild --all-documents' failed"; exit 1; fi
	$(eval BIBLIO = $(firstword $(DOCS)))
	$(eval OTHER_DOCS = $(wordlist 2, 100, $(DOCS)))
	$(MAKE) SAGE_DOCBUILD_OPTS="$(SAGE_DOCBUILD_OPTS) --no-prune-empty-dirs" doc-html--$(subst /,-,$(BIBLIO))
	$(MAKE) SAGE_DOCBUILD_OPTS="$(SAGE_DOCBUILD_OPTS) --no-prune-empty-dirs" $(foreach doc, $(OTHER_DOCS), doc-html--$(subst /,-,$(doc)))
	$(MAKE) SAGE_DOCBUILD_OPTS="$(SAGE_DOCBUILD_OPTS) --no-prune-empty-dirs" doc-html--reference_top

# other documentation, html
doc-html-other: doc-html-reference
	$(eval DOCS = $(shell cd $(SAGE_ROOT) && ./sage --docbuild --all-documents all))
	@if [ -z "$(DOCS)" ]; then echo "Error: './sage --docbuild --all-documents' failed"; exit 1; fi
	$(MAKE) SAGE_DOCBUILD_OPTS="$(SAGE_DOCBUILD_OPTS) --no-prune-empty-dirs" $(foreach doc, $(wordlist 2, 100, $(DOCS)), doc-html--$(subst /,-,$(doc)))

doc-html: doc-html-reference doc-html-other

# Matches doc-pdf--developer, doc-pdf--reference-manifolds etc.
doc-pdf--%:
	cd $(SAGE_ROOT) && ./sage --docbuild $(subst -,/,$(subst doc-pdf--,,$@)) pdf $(SAGE_DOCBUILD_OPTS)

# reference manual, pdf
doc-pdf-reference: doc-inventory-reference
	$(eval DOCS = $(shell cd $(SAGE_ROOT) && ./sage --docbuild --all-documents reference))
	@if [ -z "$(DOCS)" ]; then echo "Error: './sage --docbuild --all-documents' failed"; exit 1; fi
	$(eval BIBLIO = $(firstword $(DOCS)))
	$(eval OTHER_DOCS = $(wordlist 2, 100, $(DOCS)))
	$(MAKE) SAGE_DOCBUILD_OPTS="$(SAGE_DOCBUILD_OPTS) --no-prune-empty-dirs" doc-pdf--$(subst /,-,$(BIBLIO))
	$(MAKE) SAGE_DOCBUILD_OPTS="$(SAGE_DOCBUILD_OPTS) --no-prune-empty-dirs" $(foreach doc, $(OTHER_DOCS), doc-pdf--$(subst /,-,$(doc)))
	$(MAKE) SAGE_DOCBUILD_OPTS="$(SAGE_DOCBUILD_OPTS) --no-prune-empty-dirs" doc-pdf--reference_top

# other documentation, pdf
doc-pdf-other: doc-html-reference
	$(eval DOCS = $(shell cd $(SAGE_ROOT) && ./sage --docbuild --all-documents all))
	@if [ -z "$(DOCS)" ]; then echo "Error: './sage --docbuild --all-documents' failed"; exit 1; fi
	$(MAKE) SAGE_DOCBUILD_OPTS="$(SAGE_DOCBUILD_OPTS) --no-prune-empty-dirs" $(foreach doc, $(wordlist 2, 100, $(DOCS)), doc-pdf--$(subst /,-,$(doc)))

doc-pdf: doc-pdf-reference doc-pdf-other

.PHONY: all clean \
	doc-html doc-pdf \
	doc-inventory-reference doc-html-reference doc-pdf-reference \
	doc-html-other doc-pdf-other

=== sage/build/pkgs/admcycles/requirements.txt ===
admcycles

=== sage/build/pkgs/beautifulsoup4/requirements.txt ===
beautifulsoup4

=== sage/build/pkgs/jupyterlab/requirements.txt ===
jupyterlab ~= 2.2.5

=== sage/build/pkgs/nodeenv/requirements.txt ===
nodeenv ~= 1.4.0

=== sage/build/pkgs/ore_algebra/requirements.txt ===
git+https://github.com/mkauers/ore_algebra@cfcb386f2cc1d3e044c71dfb149444355b16d775#egg=ore_algebra

=== sage/build/pkgs/sage_flatsurf/requirements.txt ===
sage-flatsurf

=== sage/build/pkgs/slabbe/requirements.txt ===
slabbe

=== sage/build/pkgs/snappy/requirements.txt ===
# Note: As of 2021-01, snappy will pull in cypari (!= cypari2) as a dependency
# if installed as a wheel but will actually use Sage's cypari2.
# cypari contains a statically linked copy of pari and other libraries
# and will remain completely unused (wastes 30M).  Snappy is about 165M.
# See https://trac.sagemath.org/ticket/31180
snappy
# cypari 2.4.0 has a broken sdist, https://trac.sagemath.org/ticket/31180
cypari !=2.4.0
# An optional database (110M uncompressed)
snappy_15_knots

=== debian/changelog ===
sagemath (9.5-4) unstable; urgency=medium

  * Remove armel, armhf, mips64el and mipsel from Architecture list
    due to continual test failures. (Closes: #1009241)

 -- Tobias Hansen <thansen@debian.org>  Fri, 15 Apr 2022 17:38:10 +0100

sagemath (9.5-3) unstable; urgency=medium

  * Update debian/rules for Python 3.10.

 -- Tobias Hansen <thansen@debian.org>  Mon, 11 Apr 2022 08:53:24 +0000

sagemath (9.5-2) unstable; urgency=medium

  * Fix command removing sage-conf dependency from setup.cfg to avoid
    spurious dependency of python3-sage on sagemath-common caused by
    dh_python3.
  * Fix command for rerunning doctests.

 -- Tobias Hansen <thansen@debian.org>  Sat, 12 Feb 2022 18:42:24 +0000

sagemath (9.5-1) unstable; urgency=medium

  * New upstream release.
  * New (Build-)Depends:
    - python3-primecountpy
  * Remove (Build-)Depends:
    - libpynac-dev
  * New patches:
    - u0-version-arb-2.22.patch                  #33189
    - d0-cygdb3.patch
  * Remove patches (applied upstream):
    - u0-trac32799-set-MPMATH_SAGE.patch         #32799
    - u0-version-arb-2.21.patch                  #32567
    - u0-version-matplotlib-3.5.patch            #32909
    - u0-version-singular-4.2.1.patch            #32001
    - u0-version-singular-4.2.1p2.patch          #32907
    - u0-version-lcalc-2.0.patch                 #32037
    - u0-version-gsl-2.7.patch                   #32607
    - u1-close-the-internal-pipe-of-multiprocessing.Process.patch #33032
    - u3-fix-i386-build.patch                    #33073

 -- Tobias Hansen <thansen@debian.org>  Thu, 10 Feb 2022 21:58:08 +0000

sagemath (9.4-3) unstable; urgency=medium

  * Add Breaks+Replaces: sagemath-common (<< 9.4-1) for python3-sage.
    (Closes: #1002849)
  * Build-Depend on and Recommend cysignals-tools to obtain backtraces
    during build.
  * Set autopkgtest restriction allow-stderr.
  * Allow up to 100 test failures during build.
  * debian/watch: Check github releases rather than tags page,
    the latter may contain only prereleases on page 1.

 -- Tobias Hansen <thansen@debian.org>  Sat, 08 Jan 2022 11:50:35 +0000

=== debian/control ===
--- 
+++ 
@@ -119,6 +119,7 @@
  ppl-dev,
 # Additional dependencies not provided by upstream:
  python3-memory-allocator,
+ python3-primecountpy,
  python-ppl-doc,
  singular (>= 1:4.2.1-p2+ds-3),
  gap-dev (>= 4.11.0),
@@ -142,8 +143,8 @@
  sagemath-database-polytopes,
 # Additional library dependencies not provided by upstream:
  libgap-dev,
- libpynac-dev (>= 0.7.29-2),
  libratpoints-dev,
+ cysignals-tools,
  maxima-sage-doc (>= 5.42.2),
  pari-doc (>= 2.11.0),
  python3-sagenb-export (>= 3.2),
@@ -214,7 +215,7 @@
 
 Package: python3-sage
 Section: python
-Architecture: any
+Architecture: amd64 arm64 i386 ppc64el s390x alpha hppa hurd-i386 ia64 kfreebsd-amd64 kfreebsd-i386 m68k powerpc ppc64 riscv64 sh4 sparc64 x32
 Depends: ${python3:Depends}, ${misc:Depends}, ${shlibs:Depends},
 # Dependencies provided by upstream doc in sage/src/doc/en/installation/debian.txt:
  bc,
@@ -312,6 +313,7 @@
  ppl-dev,
 # Additional dependencies not provided by upstream:
  python3-memory-allocator,
+ python3-primecountpy,
  python-ppl-doc,
  singular (>= 1:4.2.1-p2+ds-3),
  gap-dev (>= 4.11.0),
@@ -335,9 +337,9 @@
  sagemath-database-polytopes,
 # Additional library dependencies not provided by upstream:
  libgap-dev,
- libpynac-dev (>= 0.7.29-2),
  libratpoints-dev,
 Recommends:
+ cysignals-tools,
  maxima-sage-doc (>= 5.42.2),
  pari-doc (>= 2.11.0),
  python3-sagenb-export (>= 3.2),
@@ -353,8 +355,8 @@
  Mathematica and Matlab.
  .
  This package installs the library for Python 3.
-Breaks: sagemath (<< 9.4-1)
-Replaces: sagemath (<< 9.4-1)
+Breaks: sagemath (<< 9.4-1), sagemath-common (<< 9.4-1)
+Replaces: sagemath (<< 9.4-1), sagemath-common (<< 9.4-1)
 
 Package: sagemath-jupyter
 Architecture: all

=== debian/rules ===
--- 
+++ 
@@ -54,6 +54,11 @@
 # 3. PACKAGE BUILD
 ###############################################################################
 
+override_dh_auto_configure:
+	cd sage/pkgs/sage-setup && python3 setup.py build
+	cd sage/pkgs/sage-setup && python3 setup.py install --root=$(CURDIR)/debian/tmp0 --install-layout=deb
+	export PYTHONPATH=$(CURDIR)/debian/tmp0/usr/lib/python3/dist-packages && dh_auto_configure
+
 # We install directly after building in order to use the python package for
 # docbuild and testing. This is required both for arch and indep builds.
 debian/tmp/usr/bin/sage:
@@ -61,14 +66,14 @@
 # Generate setup.cfg etc in sage/src from .m4 files:
 	cd sage/build/pkgs/sagelib && SAGE_ROOT=$(CURDIR)/sage PATH=$(PATH):$(CURDIR)/sage/build/bin ./bootstrap
 # Remove sage-conf from setup.cfg, it can lead to a dependency on sagemath-common
-	sed -i '/sage_conf/d' sage/src/setup.cfg
-	dh_auto_build
-	dh_auto_install
+	sed -i '/sage-conf/d' sage/src/setup.cfg
+	export PYTHONPATH=$(CURDIR)/debian/tmp0/usr/lib/python3/dist-packages && dh_auto_build
+	export PYTHONPATH=$(CURDIR)/debian/tmp0/usr/lib/python3/dist-packages && dh_auto_install
 	mkdir -p debian/tmp
 	mv debian/python3-sage/usr debian/tmp/
 	rm -rf debian/python3-sage
-	mkdir -p debian/tmp/usr/lib/python3.9/dist-packages/
-	cp -f debian/sage_conf.py debian/tmp/usr/lib/python3.9/dist-packages/
+	mkdir -p debian/tmp/usr/lib/python3.10/dist-packages/
+	cp -f debian/sage_conf.py debian/tmp/usr/lib/python3.10/dist-packages/
 
 override_dh_auto_build-arch: debian/tmp/usr/bin/sage
 
@@ -77,7 +82,7 @@
 	cd sage && SAGE_ROOT=$(CURDIR)/sage PATH=$(PATH):$(CURDIR)/sage/build/bin src/doc/bootstrap
 	mv sage/src/sage sage/src/sage.bak # Use the installed sage, not the one from the source tree
 	cd sage/src && \
-	export PYTHONPATH=$(CURDIR)/debian/tmp/usr/lib/python3.9/dist-packages \
+	export PYTHONPATH=$(CURDIR)/debian/tmp/usr/lib/python3.10/dist-packages \
 	       SAGE_SRC=$(CURDIR)/sage/src \
 	       SAGE_DOC_SRC=$(CURDIR)/sage/src/doc \
 	       SAGE_DOC=$(CURDIR)/sage/src/doc \
@@ -150,6 +155,8 @@
 	rm -f sage/pkgs/sagemath-standard/sage_conf.py
 	dh_clean
 
+override_dh_auto_clean:
+
 #override_dh_strip:
 #	dh_strip -ppython3-sage --dbg-package=python3-sage-dbg
 
@@ -172,28 +179,17 @@
 
 run_tests = \
 	export PATH=$(PATH):$(CURDIR)/debian/tmp/usr/bin \
-	       PYTHONPATH=$(CURDIR)/debian/tmp/usr/lib/python3.9/dist-packages \
+	       PYTHONPATH=$(CURDIR)/debian/tmp/usr/lib/python3.10/dist-packages \
 	       SAGE_DOC=$(CURDIR)/sage/src/doc \
 	       SAGE_LOCAL=/usr && cd sage && \
 	sage -t -p $(SAGE_NUM_THREADS) --logfile=$(CURDIR)/sage/logs/ptestlong-$(1).log $(2)
 
+rerun_tests = \
+	export PATH=$(PATH):$(CURDIR)/debian/tmp/usr/bin \
+	       PYTHONPATH=$(CURDIR)/debian/tmp/usr/lib/python3.10/dist-packages \
+	       SAGE_DOC=$(CURDIR)/sage/src/doc \
+	       SAGE_LOCAL=/usr && cd sage && \
+	sage -t -p 1 -f --logfile=$(CURDIR)/sage/logs/ptestlong-$(1).log $(2)
+
 run_tests_with_retry = \
 	$(run_tests); cd "$(CURDIR)" && \
-	if $(TESTS_MK) LOGFILE=sage/logs/ptestlong-$(1).log MAX_TEST_FAILURES=$(3) had-few-failures; then :; else \
-	  $(TESTS_MK) LOGFILE=sage/logs/ptestlong-$(1).log MAX_TEST_FAILURES=$(3) had-not-too-many-failures && \
-	  mv sage/logs/ptestlong-$(1).log sage/logs/ptestlong-$(1).log.1 && \
-	  { $(run_tests) -p 1 -f; cd "$(CURDIR)" && \
-	  $(TESTS_MK) LOGFILE=sage/logs/ptestlong-$(1).log MAX_TEST_FAILURES=$(3) had-few-failures; }; \
-	fi
-
-override_dh_auto_test-arch:
-ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
-	mkdir -p sage/logs
-	$(call run_tests_with_retry,arch,$(SAGE_TEST_FLAGS_ARCH) src/sage,150)
-endif
-
-override_dh_auto_test-indep:
-ifeq (,$(filter nodoc,$(DEB_BUILD_PROFILES)))
-ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
-	mkdir -p sage/logs
-	$(call run_tests_with_retry,indep,$(SAGE_TEST_FLAGS_INDEP) src/doc src/sage/misc/sagedoc.py,25)

=== debian/tests/control ===
Test-Command: HOME=$(pwd) SAGE_SRC=$(pwd)/sage/src sage -t -p --logfile=ptestlong.log sage/src/sage || make -s --no-print-directory -f debian/tests.mk had-few-failures
Depends: sagemath-jupyter, sagemath-doc
Restrictions: rw-build-tree, skip-not-installable, allow-stderr

=== debian/watch ===
version=4
opts=filenamemangle=s/.+\/v?(\d\S+)\.tar\.gz/sage-$1\.tar\.gz/ \
  https://github.com/sagemath/sage/releases .*/([\d\.]+)\.tar\.gz
